KeeperException.Code (Apache ZooKeeper - Server 3.7.0 API)
Date: 2021-03-17

org.apache.zookeeper

## Enum KeeperException.Code

- java.lang.Object
- - java.lang.Enum<KeeperException.Code>
  - - org.apache.zookeeper.KeeperException.Code

- All Implemented Interfaces:
    Serializable, Comparable<KeeperException.Code>, KeeperException.CodeDeprecated
  Enclosing class:
    KeeperException

      @InterfaceAudience.Public
      public static enum KeeperException.Code
      extends Enum<KeeperException.Code>
      implements KeeperException.CodeDeprecated

  Codes which represent the various KeeperException types. This enum replaces the deprecated earlier static final int constants. The old, deprecated, values are in "camel case" while the new enum values are in all CAPS.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `APIERROR` API errors.
    `AUTHFAILED` Client authentication failed
    `BADARGUMENTS` Invalid arguments
    `BADVERSION` Version conflict In case of reconfiguration: reconfig requested from config version X but last seen config has a different version Y
    `CONNECTIONLOSS` Connection to the server has been lost
    `DATAINCONSISTENCY` A data inconsistency was found
    `EPHEMERALONLOCALSESSION` Attempt to create ephemeral node on a local session
    `INVALIDACL` Invalid ACL specified
    `INVALIDCALLBACK` Invalid callback specified
    `MARSHALLINGERROR` Error while marshalling or unmarshalling data
    `NEWCONFIGNOQUORUM` No quorum of new config is connected and up-to-date with the leader of last commmitted config - try invoking reconfiguration after new servers are connected and synced
    `NOAUTH` Not authenticated
    `NOCHILDRENFOREPHEMERALS` Ephemeral nodes may not have children
    `NODEEXISTS` The node already exists
    `NONODE` Node does not exist
    `NOTEMPTY` The node has children
    `NOTREADONLY` State-changing request is passed to read-only server
    `NOWATCHER` Attempts to remove a non-existing watcher
    `OK` Everything is OK
    `OPERATIONTIMEOUT` Operation timeout
    `QUOTAEXCEEDED` Exceeded the quota that was set on the path.
    `RECONFIGDISABLED` Attempts to perform a reconfiguration operation when reconfiguration feature is disabled.
    `RECONFIGINPROGRESS` Another reconfiguration is in progress -- concurrent reconfigs not supported (yet)
    `REQUESTTIMEOUT` Request not completed within max allowed time.
    `RUNTIMEINCONSISTENCY` A runtime inconsistency was found
    `SESSIONCLOSEDREQUIRESASLAUTH` The session has been closed by server because server requires client to do authentication with configured authentication scheme at the server, but client is not configured with required authentication scheme or configured but authentication failed (i.e.
    `SESSIONEXPIRED` The session has been expired by the server
    `SESSIONMOVED` Session moved to another server, so operation is ignored
    `SYSTEMERROR` System and server-side errors.
    `THROTTLEDOP` Operation was throttled and not executed at all.
    `UNIMPLEMENTED` Operation is unimplemented
    `UNKNOWNSESSION` Unknown session (internal server use only)

  - ### Field Summary

    - ### Fields inherited from interface org.apache.zookeeper.KeeperException.CodeDeprecated

      `APIError, AuthFailed, BadArguments, BadVersion, ConnectionLoss, DataInconsistency, EphemeralOnLocalSession, InvalidACL, InvalidCallback, MarshallingError, NewConfigNoQuorum, NoAuth, NoChildrenForEphemerals, NodeExists, NoNode, NotEmpty, Ok, OperationTimeout, ReconfigInProgress, RuntimeInconsistency, SessionExpired, SystemError, Unimplemented, UnknownSession`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static KeeperException.Code` | `get(int code)` Get the Code value for a particular integer error code
    `int` | `intValue()` Get the int value for a particular Code.
    `static KeeperException.Code` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static KeeperException.Code[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### OK

          public static final KeeperException.Code OK

      Everything is OK

    - #### SYSTEMERROR

          public static final KeeperException.Code SYSTEMERROR

      System and server-side errors. This is never thrown by the server, it shouldn't be used other than to indicate a range. Specifically error codes greater than this value, but lesser than `APIERROR`, are system errors.

    - #### RUNTIMEINCONSISTENCY

          public static final KeeperException.Code RUNTIMEINCONSISTENCY

      A runtime inconsistency was found

    - #### DATAINCONSISTENCY

          public static final KeeperException.Code DATAINCONSISTENCY

      A data inconsistency was found

    - #### CONNECTIONLOSS

          public static final KeeperException.Code CONNECTIONLOSS

      Connection to the server has been lost

    - #### MARSHALLINGERROR

          public static final KeeperException.Code MARSHALLINGERROR

      Error while marshalling or unmarshalling data

    - #### UNIMPLEMENTED

          public static final KeeperException.Code UNIMPLEMENTED

      Operation is unimplemented

    - #### OPERATIONTIMEOUT

          public static final KeeperException.Code OPERATIONTIMEOUT

      Operation timeout

    - #### BADARGUMENTS

          public static final KeeperException.Code BADARGUMENTS

      Invalid arguments

    - #### NEWCONFIGNOQUORUM

          public static final KeeperException.Code NEWCONFIGNOQUORUM

      No quorum of new config is connected and up-to-date with the leader of last commmitted config - try invoking reconfiguration after new servers are connected and synced

    - #### RECONFIGINPROGRESS

          public static final KeeperException.Code RECONFIGINPROGRESS

      Another reconfiguration is in progress -- concurrent reconfigs not supported (yet)

    - #### UNKNOWNSESSION

          public static final KeeperException.Code UNKNOWNSESSION

      Unknown session (internal server use only)

    - #### APIERROR

          public static final KeeperException.Code APIERROR

      API errors. This is never thrown by the server, it shouldn't be used other than to indicate a range. Specifically error codes greater than this value are API errors (while values less than this indicate a `SYSTEMERROR`).

    - #### NONODE

          public static final KeeperException.Code NONODE

      Node does not exist

    - #### NOAUTH

          public static final KeeperException.Code NOAUTH

      Not authenticated

    - #### BADVERSION

          public static final KeeperException.Code BADVERSION

      Version conflict In case of reconfiguration: reconfig requested from config version X but last seen config has a different version Y

    - #### NOCHILDRENFOREPHEMERALS

          public static final KeeperException.Code NOCHILDRENFOREPHEMERALS

      Ephemeral nodes may not have children

    - #### NODEEXISTS

          public static final KeeperException.Code NODEEXISTS

      The node already exists

    - #### NOTEMPTY

          public static final KeeperException.Code NOTEMPTY

      The node has children

    - #### SESSIONEXPIRED

          public static final KeeperException.Code SESSIONEXPIRED

      The session has been expired by the server

    - #### INVALIDCALLBACK

          public static final KeeperException.Code INVALIDCALLBACK

      Invalid callback specified

    - #### INVALIDACL

          public static final KeeperException.Code INVALIDACL

      Invalid ACL specified

    - #### AUTHFAILED

          public static final KeeperException.Code AUTHFAILED

      Client authentication failed

    - #### SESSIONMOVED

          public static final KeeperException.Code SESSIONMOVED

      Session moved to another server, so operation is ignored

    - #### NOTREADONLY

          public static final KeeperException.Code NOTREADONLY

      State-changing request is passed to read-only server

    - #### EPHEMERALONLOCALSESSION

          public static final KeeperException.Code EPHEMERALONLOCALSESSION

      Attempt to create ephemeral node on a local session

    - #### NOWATCHER

          public static final KeeperException.Code NOWATCHER

      Attempts to remove a non-existing watcher

    - #### REQUESTTIMEOUT

          public static final KeeperException.Code REQUESTTIMEOUT

      Request not completed within max allowed time.

    - #### RECONFIGDISABLED

          public static final KeeperException.Code RECONFIGDISABLED

      Attempts to perform a reconfiguration operation when reconfiguration feature is disabled.

    - #### SESSIONCLOSEDREQUIRESASLAUTH

          public static final KeeperException.Code SESSIONCLOSEDREQUIRESASLAUTH

      The session has been closed by server because server requires client to do authentication with configured authentication scheme at the server, but client is not configured with required authentication scheme or configured but authentication failed (i.e. wrong credential used.).

    - #### QUOTAEXCEEDED

          public static final KeeperException.Code QUOTAEXCEEDED

      Exceeded the quota that was set on the path.

    - #### THROTTLEDOP

          public static final KeeperException.Code THROTTLEDOP

      Operation was throttled and not executed at all. This error code indicates that zookeeper server is under heavy load and can't process incoming requests at full speed; please retry with back off.

  - ### Method Detail

    - #### values

          public static KeeperException.Code[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (KeeperException.Code c : KeeperException.Code.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static KeeperException.Code valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### intValue

          public int intValue()

      Get the int value for a particular Code.
      Returns:
        error code as integer

    - #### get

          public static KeeperException.Code get(int code)

      Get the Code value for a particular integer error code
      Parameters:
        `code` - int error code
      Returns:
        Code value corresponding to specified int code, or null

Copyright © 2008–2021 The Apache Software Foundation. All rights reserved.